#include "stdafx.h"
#include "HardwareID.h"

//HardwareID::HardwareID()
//: device_type(NULL)
//, ven_(NULL)
//, dev_(NULL)
//, subsys_(NULL)
//, cc_(NULL)
//{
//}

//HardwareID::HardwareID(HardwareID const &right)
//: device_type(NULL)
//, ven_(right.ven_)
//, dev_(right.dev_)
//, subsys_(right.subsys_)
//, cc_(right.cc_)
//{
//	if (right.device_type != NULL) {
//		size_t len = wcslen(right.device_type);
//		this->device_type = new wchar_t[len + 1];
//		memcpy(const_cast<wchar_t*>(this->device_type), right.device_type, (len + 1)*sizeof(wchar_t));
//	}
//}

//template <class T> bool areSameValue(T const *arg1, T const *arg2)
//{
//	return (arg1 != NULL && arg2 != NULL && *arg1 == *arg2);
//}

HardwareID::HardwareID(std::wstring const &str)
: device_type(NULL)
, ven_(NULL)
, dev_(NULL)
//, subsys_(NULL)
, cc_high_(NULL)
, cc_low_(NULL)
{
	this->create(str);
}

//HardwareID::HardwareID(std::vector<std::wstring> const &strs)
//: device_type(NULL)
//, ven_(0)
//, dev_(0)
//, subsys_(0)
//, cc_(0)
//{
//	for (std::vector<std::wstring>::const_iterator it = strs.begin(); it != strs.end(); ++it) {
//		this->create(*it);
//	}
//}

void HardwareID::create(const std::wstring &str)
{
	size_t const buf_count = str.length() + 1;
	boost::scoped_array<wchar_t> buf(new wchar_t[buf_count]);
	std::memcpy(buf.get(), str.c_str(), buf_count*sizeof(wchar_t));
	// 啶
	::CharUpper(buf.get());
	// 擪PCI
	wchar_t *ptr = wcschr(buf.get(), L'\\');
	if (this->device_type == NULL) {
		if (ptr != NULL) {
			*ptr = L'\0';
		}
		size_t device_type_len = wcslen(buf.get());
		wchar_t *device_type_buf = new wchar_t[device_type_len + 1];
		memcpy(device_type_buf, buf.get(), (device_type_len + 1)*sizeof(wchar_t));
		this->device_type = device_type_buf;
	}
	if (ptr == NULL) {
		return;
	}
	++ptr;
	while (*ptr != L'\0') {
		switch (*ptr) {
		case L'V':
			{
				wchar_t *ptr2 = wcschr(ptr, L'&');
				wchar_t *ptr3 = ((ptr2 == NULL) ? (buf.get() + str.length()) : ptr2);
				if (this->ven_ == NULL && ptr3 - ptr == 8 && memcmp(ptr, L"VEN_", 8) == 0) {
					wchar_t *ptr4;
					long n = wcstol(ptr + 4, &ptr4, 16);
					if (ptr4 == ptr3) {
						this->ven_ = new uint16_t;
						*(this->ven_) = static_cast<uint16_t>(n);
					}
				}
				ptr = ((ptr2 == NULL) ? ptr3 : ptr2 + 1);
			}
			break;
		case L'D':
			{
				wchar_t *ptr2 = wcschr(ptr, L'&');
				wchar_t *ptr3 = ((ptr2 == NULL) ? (buf.get() + str.length()) : ptr2);
				if (this->dev_ == NULL && ptr3 - ptr == 8 && memcmp(ptr, L"DEV_", 8) == 0) {//
					wchar_t *ptr4;
					long n = wcstol(ptr + 4, &ptr4, 16);
					if (ptr4 == ptr3) {
						this->dev_ = new uint16_t;
						*(this->dev_) = static_cast<uint16_t>(n);//
					}
				}
				ptr = ((ptr2 == NULL) ? ptr3 : ptr2 + 1);
			}
			break;
		//case L'S':
		//	{
		//		wchar_t *ptr2 = wcschr(ptr, L'&');
		//		wchar_t *ptr3 = ((ptr2 == NULL) ? (buf.get() + str.length()) : ptr2);
		//		if (this->subsys_ == NULL && ptr3 - ptr == 15 && memcmp(ptr, L"SUBSYS_", 14) == 0) {//
		//			wchar_t *ptr4;
		//			long n = wcstol(ptr + 7, &ptr4, 16);
		//			if (ptr4 == ptr3) {
		//				this->subsys_ = new uint32_t;
		//				*(this->subsys_) = n;//
		//			}
		//		}
		//		ptr = ((ptr2 == NULL) ? ptr3 : ptr2 + 1);
		//	}
		//	break;
		case L'C':
			{
				wchar_t *separator_ptr = wcschr(ptr, L'&');
				wchar_t *end_ptr = ((separator_ptr == NULL) ? (buf.get() + str.length()) : separator_ptr);
				if (this->cc_high_ == NULL && this->cc_low_ == NULL) {
					size_t const cc_len = end_ptr - ptr;
					if ((cc_len == 7 || cc_len == 9) && memcmp(ptr, L"CC_", 6) == 0) {//
						wchar_t *ptr3 = ptr + 7;
						*ptr3 = L'\0';
						wchar_t *ptr4;
						long n = wcstol(ptr + 3, &ptr4, 16);
						if (ptr4 == ptr3) {
							if (cc_len == 7) {
								this->cc_high_ = new uint16_t;
								*(this->cc_high_) = static_cast<uint16_t>(n);
							} else {
								this->cc_high_ = new uint16_t;
								*(this->cc_high_) = static_cast<uint16_t>(n >> 8);
								this->cc_low_ = new uint8_t;
								*(this->cc_low_) = (n & 0xFF);
							}
						}
					}
				}
				ptr = ((separator_ptr == NULL) ? end_ptr : separator_ptr + 1);
			}
			break;
		default:
			{
				wchar_t *ptr2 = wcschr(ptr, L'&');
				wchar_t *ptr3 = ((ptr2 == NULL) ? (buf.get() + str.length()) : ptr2);
				ptr = ((ptr2 == NULL) ? ptr3 : ptr2 + 1);
			}
			break;
		}
	}
}

HardwareID::~HardwareID()
{
	delete[] (this->device_type);
	delete (this->ven_);
	delete (this->dev_);
	//delete (this->subsys_);
	delete (this->cc_high_);
	delete (this->cc_low_);
}

bool HardwareID::empty() const
{
	return this->device_type == NULL
		&& this->ven_ == NULL
		&& this->dev_ == NULL
		//&& this->subsys_ == NULL
		&& this->cc_high_ == NULL;
}

//HardwareID& HardwareID::operator=(HardwareID const &right)
//{
//	this->ven_ = right.ven_;
//	this->dev_ = right.dev_;
//	this->subsys_ = right.subsys_;
//	this->cc_ = right.cc_;
//	if (right.device_type != NULL) {
//		size_t r_len = wcslen(right.device_type);
//		if (this->device_type != NULL) {
//			if (wcslen(this->device_type) != r_len) {
//				delete[] (this->device_type);
//				this->device_type = new wchar_t[r_len + 1];
//			}
//		} else {
//			this->device_type = new wchar_t[r_len + 1];
//		}
//		memcpy(const_cast<wchar_t*>(this->device_type), right.device_type, (r_len + 1)*sizeof(wchar_t));
//	} else if (this->device_type != NULL) {
//		delete[] (this->device_type);
//		this->device_type = NULL;
//	}
//	return *this;
//}

//bool HardwareID::operator<(HardwareID const &l) const
//{
//	if (wcscmp(this->device_type, l.device_type) == 0) {
//		if (this->ven_ == l.ven_) {
//			if (this->dev_ ==  l.dev_) {
//				if (this->subsys_ == l.subsys_) {
//					return this->cc_ < l.cc_;
//				} else {
//					return this->subsys_ < l.subsys_;
//				}
//			} else {
//				return this->dev_ < l.dev_;
//			}
//		} else {
//			return this->ven_ < l.ven_;
//		}
//	} else {
//		return wcscmp(this->device_type, l.device_type) == -1;
//	}
//}

bool HardwareID::operator==(HardwareID const &right) const
{
	return wcscmp(this->device_type, right.device_type) == 0
		&& ((this->ven_ == NULL && right.ven_ == NULL) || (this->ven_ != NULL && right.ven_ != NULL && *(this->ven_) == *(right.ven_)))
		&& ((this->dev_ == NULL && right.dev_ == NULL) || (this->dev_ != NULL && right.dev_ != NULL && *(this->dev_) == *(right.dev_)))
		//&& ((this->subsys_ == NULL && right.subsys_ == NULL) || (this->subsys_ != NULL && right.subsys_ != NULL && *(this->subsys_) == *(right.subsys_)))
		&& ((this->cc_high_ == NULL && right.cc_high_ == NULL) || (this->cc_high_ != NULL && right.cc_high_ != NULL && *(this->cc_high_) == *(right.cc_high_)))
		&& ((this->cc_low_ == NULL && right.cc_low_ == NULL) || (this->cc_low_ != NULL && right.cc_low_ != NULL && *(this->cc_low_) == *(right.cc_low_)));
}

bool HardwareID::operator!=(HardwareID const &other_instance) const
{
	return !(*this == other_instance);
}

std::wstring HardwareID::getString() const
{
	int counter = 0;
	std::wstringstream ss;
	ss << this->device_type;
	ss << std::hex << std::uppercase;
	if (this->ven_ != NULL) {
		ss << (counter == 0 ? L"\\" : L"&") << L"VEN_";
		ss.width(4);
		ss.fill(L'0');
		ss << *(this->ven_);
		++counter;
	}
	if (this->dev_ != NULL) {
		ss << (counter == 0 ? L"\\" : L"&") << L"DEV_";
		ss.width(4);
		ss.fill(L'0');
		ss << *(this->dev_);
		++counter;
	}
	//if (this->subsys_ != NULL) {
	//	ss << (counter == 0 ? L"\\" : L"&") << L"SUBSYS_";
	//	ss.width(8);
	//	ss.fill(L'0');
	//	ss << *(this->subsys_);
	//	++counter;
	//}
	if (this->cc_high_ != NULL) {
		ss << (counter == 0 ? L"\\" : L"&") << L"CC_";
		ss.width(4);
		ss.fill(L'0');
		ss << *(this->cc_high_);
		if (this->cc_low_ != NULL) {
			ss.width(2);
			ss.fill(L'0');
			ss << *(this->cc_low_);
		}
		++counter;
	}
	return ss.str();
}

int HardwareID::match(HardwareID const &inf_hwid) const
{
	// PCI\VEN_8086&DEV_27C5&CC_010601
	//  PCI\VEN_8086&DEV_27C5&CC_0106
	//  PCI\VEN_8086&DEV_27C5
	// PCI\VEN_8086&DEV_27C5&CC_0106
	//  PCI\VEN_8086&DEV_27C5
	// PCI\VEN_8086&DEV_27C5

	// PCI\VEN_8086&CC_010601
	// PCI\VEN_8086&CC_0106
	// PCI\VEN_8086
	// PCI\CC_010601
	// PCI\CC_0101
	// Internal_IDE_Channel
	if (_wcsicmp(this->device_type, inf_hwid.device_type) == 0) {
		if (this->ven_ != NULL && this->dev_ != NULL) {
			if (inf_hwid.ven_ != NULL && inf_hwid.dev_ != NULL && *(this->ven_) == *(inf_hwid.ven_) && *(this->dev_) == *(inf_hwid.dev_)) {
				if (this->cc_high_ != NULL && inf_hwid.cc_high_ != NULL) {
					if (*(this->cc_high_) == *(inf_hwid.cc_high_)) {
						return 2;
					} else {
						return 0;
					}
				} else {
					return 1;
				}
			} else {
				return 0;
			}
		} else if (*this == inf_hwid) {
			return 1;
		} else {
			return 0;
		}
		//if (areSameValue(this->ven_, inf_hwid.ven_)) {
		//	if (areSameValue(this->dev_, inf_hwid.dev_)) {
		//		if (areSameValue(this->cc_high_, inf_hwid.cc_high_)) {
		//		} else {
		//			return 1;
		//		}
		//	} else if (this->dev_ == NULL && inf_hwid.dev_ == NULL) {
		//		return 1;
		//	} else {
		//		return 0;
		//	}
		//} else (this->ven_ == NULL && inf_hwid.ven_ == NULL) {
		//	//
		//} else {
		//	return 0;
		//}
	}
	return 0;
}
