#include "stdafx.h"
#include "ModelsTargetOSVer.h"

ModelsTargetOSVer::ModelsTargetOSVer()
{
}

ModelsTargetOSVer::ModelsTargetOSVer(std::wstring const &str)
: os_ver_str(str)
{
}

std::wstring ModelsTargetOSVer::getVerString() const
{
	return this->os_ver_str.empty() ? _T("") : (_T('.') + this->os_ver_str);
}

unsigned int ModelsTargetOSVer::getArchitectureFlag() const
{
	// '.'̈ʒu܂ł̕擾
	const std::wstring architecture_str = tokenize(this->os_ver_str, _T('.'), 0);
	// x64phCo NTamd64 w肳ĂƂ̂݃CXg[̂AMD64(x64)͏O
	unsigned int architecture_flag = static_cast<unsigned int>(~AMD64);
	if (_wcsicmp(architecture_str.c_str(), _T("nt")) == 0) {
		architecture_flag = X86 /*| AMD64*/ | IA64;
	} else if (_wcsicmp(architecture_str.c_str(), _T("ntx86")) == 0) {
		architecture_flag = X86;
	} else if (_wcsicmp(architecture_str.c_str(), _T("ntamd64")) == 0) {
		architecture_flag = AMD64;
	} else if (_wcsicmp(architecture_str.c_str(), _T("ntia64")) == 0) {
		architecture_flag = IA64;
	}
	return architecture_flag;
}

uint32_t ModelsTargetOSVer::getVersion() const
{
	uint16_t major_ver = 0;
	uint16_t minor_ver = 0;
	std::wstring str = tokenize(this->os_ver_str, _T('.'), 1);
	if (!str.empty()) {
		major_ver = static_cast<uint16_t>(::_tstoi(str.c_str()));
	}
	str = tokenize(this->os_ver_str, _T('.'), 2);
	if (!str.empty()) {
		minor_ver = static_cast<uint16_t>(::_tstoi(str.c_str()));
	}
	return MAKELONG(minor_ver, major_ver);
}

// ؂蕶ŕAw肳ꂽԂ̕Ԃ
std::wstring ModelsTargetOSVer::tokenize(
	std::wstring const &str,
	wchar_t token,
	unsigned int index)
{
	using std::wstring;
	std::wstring::size_type target_pos = 0;
	std::wstring::size_type period_pos = str.find(token, target_pos);
	if (index > 0) {
		for (unsigned int i = 0; i < index; ++i) {
			if (period_pos == std::wstring::npos) {
				return _T("");
			}
			target_pos = period_pos + 1;
			period_pos = str.find(token, target_pos);
		}
	}
	std::wstring::size_type length =
		(period_pos != std::wstring::npos ? period_pos - target_pos : std::wstring::npos);
	return str.substr(target_pos, length);
}

unsigned int ModelsTargetOSVer::getArchitectureFlagFromString(std::wstring const &str)
{
	if (str == _T("X86")) {
		return X86;
	} else if (str == _T("AMD64")) {
		return AMD64;
	} else if (str == _T("IA64")) {
		return IA64;
	}
	return 0;
}
