#include "StdAfx.h"
#include "SATAControllerInfo.h"

wchar_t getSystemDriveLetter()
{
	unsigned int windir_buf_size = ::GetWindowsDirectory(NULL, 0);
	wchar_t *windir = new wchar_t[windir_buf_size];
	::GetWindowsDirectory(windir, windir_buf_size);
	wchar_t const system_drive_letter = windir[0];
	delete[] windir;
	return system_drive_letter;
}

SATAControllerInfo::SATAControllerInfo(DEVINST devinst)
: di(devinst)
{
	//// VXehCũfBXNԍ擾
	//MyLib::StorageDeviceNumber sdn(getSystemDriveLetter());

	//DeviceInfoList dil(&GUID_DEVCLASS_HDC/*&GUID_DEVINTERFACE_DISK*/, NULL, DIGCF_PRESENT /*| DIGCF_DEVICEINTERFACE*/);
	//for (int i = 0; ; ++i) {
	//	SP_DEVICE_INTERFACE_DATA device_if_data;
	//	::ZeroMemory(&device_if_data, sizeof(device_if_data));
	//	device_if_data.cbSize = sizeof(device_if_data);
	//	bool succeeded = ::SetupDiEnumDeviceInterfaces(dil.get(), NULL, &GUID_DEVINTERFACE_DISK, i, &device_if_data) != 0;
	//	if (!succeeded) {
	//		DWORD err_code = ::GetLastError();
	//		if (err_code == ERROR_NO_MORE_ITEMS) {
	//			break;
	//		} else {
	//			BOOST_THROW_EXCEPTION(MyLib::SetupAPIException(HRESULT_FROM_SETUPAPI(err_code)));
	//		}
	//	}

	//	DWORD device_if_detail_data_size;
	//	::SetupDiGetDeviceInterfaceDetail(dil.get(), &device_if_data, NULL, 0, &device_if_detail_data_size, NULL);
	//	boost::scoped_array<char> device_if_detail_data_buf(new char[device_if_detail_data_size]);
	//	SP_DEVICE_INTERFACE_DETAIL_DATA *device_if_detail_data = reinterpret_cast<SP_DEVICE_INTERFACE_DETAIL_DATA*>(device_if_detail_data_buf.get());
	//	device_if_detail_data->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
	//	SP_DEVINFO_DATA devinfo_data;
	//	::ZeroMemory(&devinfo_data, sizeof(devinfo_data));
	//	devinfo_data.cbSize = sizeof(devinfo_data);
	//	succeeded = ::SetupDiGetDeviceInterfaceDetail(dil.get(), &device_if_data, device_if_detail_data, device_if_detail_data_size, &device_if_detail_data_size, &devinfo_data) != 0;
	//	if (!succeeded) {
	//		BOOST_THROW_EXCEPTION(MyLib::SetupAPIException());
	//	}

	//	MyLib::StorageDeviceNumber sdn2(std::wstring(device_if_detail_data->DevicePath));
	//	if (sdn.getDeviceNumber() == sdn2.getDeviceNumber() && sdn.getDeviceType() == sdn2.getDeviceType()) {
	//		// fBXNԍVXehCû̂ƈv
	//		// efoCX擾
	//		DEVINST di1;
	//		CONFIGRET ret = ::CM_Get_Parent(&di1, devinfo_data.DevInst, 0);
	//		if (ret != CR_SUCCESS) {
	//			BOOST_THROW_EXCEPTION(MyLib::Win32Exception(ret));
	//		}
	//		// fBXNhCu̐e"ATA Channel 0"ƂƂ̑΍
	//		unsigned long buf_size = 0;
	//		ret = ::CM_Get_DevNode_Registry_Property(di1, CM_DRP_HARDWAREID, NULL, NULL, &buf_size, 0);
	//		if (ret == CR_BUFFER_SMALL && buf_size > 8) {
	//			// n[hEFAID"PCI\\..."ȂOKƂ
	//			boost::scoped_array<char> buf(new char[buf_size]);
	//			::CM_Get_DevNode_Registry_Property(di1, CM_DRP_HARDWAREID, NULL, buf.get(), &buf_size, 0);
	//			if (memcmp(buf.get(), L"PCI\\", 8) == 0) {
	//				this->di = di1;
	//				return;
	//			}
	//		}
	//		// ɐẽfoCX擾
	//		ret = ::CM_Get_Parent(&(this->di), di1, 0);
	//		if (ret != CR_SUCCESS) {
	//			BOOST_THROW_EXCEPTION(MyLib::Win32Exception(ret));
	//		}
	//	}
	//}
}

char* SATAControllerInfo::getRegistryProperty(DEVINST devinst, unsigned long property_code)
{
	unsigned long buf_size = 0;
	CONFIGRET ret = ::CM_Get_DevNode_Registry_Property(devinst, property_code, NULL, NULL, &buf_size, 0);
	if (ret != CR_BUFFER_SMALL) {
		return NULL;
	}
	char *buf = new char[buf_size];
	::CM_Get_DevNode_Registry_Property(devinst, property_code, NULL, buf, &buf_size, 0);
	return buf;
}

std::wstring SATAControllerInfo::getDisplayName() const
{
	// \擾
	char *buf = getRegistryProperty(this->di, CM_DRP_FRIENDLYNAME);
	if (buf == NULL) {
		buf = getRegistryProperty(this->di, CM_DRP_DEVICEDESC);
		if (buf == NULL) {
			return L"";
		}
	}
	boost::scoped_array<char> display_name_buf(buf);

	return reinterpret_cast<wchar_t const *>(display_name_buf.get());
}

std::vector<std::wstring> SATAControllerInfo::getHardwareIDs() const
{
	// n[hEFAID擾
	std::vector<std::wstring> result;
	char *buf = getRegistryProperty(this->di, CM_DRP_HARDWAREID);
	if (buf != NULL) {
		boost::scoped_array<char> hwids_buf(buf);
		for (wchar_t const *ptr = reinterpret_cast<wchar_t const *>(hwids_buf.get()); *ptr != L'\0'; ++ptr) {
			result.push_back(ptr);
			ptr += wcslen(ptr);
		}
	}
	return result;
}

std::vector<std::wstring> SATAControllerInfo::getCompatibleIDs() const
{
	std::vector<std::wstring> result;
	char *buf = getRegistryProperty(this->di, CM_DRP_COMPATIBLEIDS);
	if (buf != NULL) {
		boost::scoped_array<char> hwids_buf(buf);
		for (wchar_t const *ptr = reinterpret_cast<wchar_t const *>(hwids_buf.get()); *ptr != L'\0'; ++ptr) {
			result.push_back(ptr);
			ptr += wcslen(ptr);
		}
	}
	return result;
}
