#pragma once

namespace MyLib {

	inline std::wstring toUpper(std::wstring const &str)
	{
		size_t buf_count = str.length() + 1;
		boost::scoped_array<wchar_t> buf(new wchar_t[buf_count]);
		std::memcpy(buf.get(), str.c_str(), buf_count*sizeof(wchar_t));
		::CharUpper(buf.get());
		return buf.get();
	}

	inline std::wstring toLower(std::wstring const &str)
	{
		size_t buf_count = str.length() + 1;
		boost::scoped_array<wchar_t> buf(new wchar_t[buf_count]);
		std::memcpy(buf.get(), str.c_str(), buf_count*sizeof(wchar_t));
		::CharLower(buf.get());
		return buf.get();
	}

//=======================================================================
// 啶EʂȂ̔r֐
//=======================================================================
inline int compareStringNoCase(std::wstring const &left, std::wstring const &right)
{
	// lstrcmpi()ECompareString()gȂ̂́A
	// 啶E𓯈ꎋt@C̋KƈقȂ邽߁B
	// [http://d.hatena.ne.jp/hasegawayosuke/20060125/1138185283]
	// tolower()gȂ̂́A}`oCgɑΉ邽߁B

	// ׂ̕đ啶ɂ
	size_t left_buf_count = left.length() + 1;
	boost::scoped_array<wchar_t> left_buf(new wchar_t[left_buf_count]);
	std::memcpy(left_buf.get(), left.c_str(), left_buf_count*sizeof(wchar_t));
	::CharUpper(left_buf.get());
	// ׂ̕đ啶ɂ
	size_t right_buf_count = right.length() + 1;
	boost::scoped_array<wchar_t> right_buf(new wchar_t[right_buf_count]);
	std::memcpy(right_buf.get(), right.c_str(), right_buf_count*sizeof(wchar_t));
	::CharUpper(right_buf.get());
	// r
	size_t const comp_size = std::min(left_buf_count, right_buf_count)*sizeof(wchar_t);
	int const result = std::memcmp(&left_buf[0], &right_buf[0], comp_size);
	if (result == 0) {
		if (left_buf_count > right_buf_count) {
			return 1;
		}
		if (left_buf_count < right_buf_count) {
			return -1;
		}
	}
	return result;
}

//=======================================================================
// 啶EʂȂ̔r֐IuWFNg
//=======================================================================
struct LessNoCase
	: public std::binary_function<std::wstring, std::wstring, bool>
{
	bool operator()(const std::wstring& _Left, const std::wstring& _Right) const
	{	// apply operator> to operands
		return compareStringNoCase(_Left, _Right) < 0;
	}
};

};  // namespace MyLib